      program Grafika
      parameter (NMAX=800, KDEF=50)  
c     Popravi se ostale NMAX (glej izracun.for)
c     KDEF podaja velikost deformacije
      integer dim,joints,members,incid(NMAX,3),v1,v2,st,nt
      real coord(NMAX,3),no(NMAX),pomik(NMAX,3)
      real co1,co2,co3,ntr,dd,f(4,4)
      real x(NMAX),y(NMAX),a(4,4),b(4,4),c(4,4),d(4,4),e(4,4)
      real xd(NMAX),yd(NMAX),z(NMAX),zd(NMAX),fi
      character cnode*20,opcija*10

      open(unit=4,file='gks.bin',access='direct',
     &form='binary',recl=58)

      read(4,rec=1)dim,joints,members

      do i=1,joints
      read(4,rec=2+i)co1,co2,co3
      coord(i,1)=co1
	if(coord(i,1).gt.xmax)then
	xmax=coord(i,1)
	end if
	if(coord(i,1).lt.xmin)then
	xmin=coord(i,1)
	end if
      coord(i,2)=co2
	if(coord(i,2).gt.ymax)then
	ymax=coord(i,2)
	end if
	if(coord(i,2).lt.ymin)then
	ymin=coord(i,2)
	end if
      coord(i,3)=co3
	if(coord(i,3).gt.zmax)then
	zmax=coord(i,3)
	end if
	if(coord(i,3).lt.zmin)then
	zmin=coord(i,3)
	end if
      end do

      do j=1,members
      read(4,rec=3+joints+j)i,v1,v2,ntr
      incid(i,1)=v1
      incid(i,2)=v2
      no(i)=ntr
      end do

      do i=1,joints
         do j=1,dim
         read(4,rec=4+joints+members+dim*(i-1)+j)dd
	 pomik(i,j)=dd
         end do
      end do

      lx=xmax-xmin
      ly=ymax-ymin		       !izracunam maksimalno dolzino, ki je
      lz=zmax-zmin		       !pomembna za koordinate okna

      lmax=lx
      if(ly.gt.lmax) lmax=ly
      if(lz.gt.lmax) lmax=lz

496   continue

      do i=1,joints
	   x(i)=coord(i,1)
	   y(i)=coord(i,2)
	   z(i)=coord(i,3)
	   xd(i)=x(i)+KDEF*pomik(i,1)
	   yd(i)=y(i)+KDEF*pomik(i,2)
	   zd(i)=z(i)+KDEF*pomik(i,3)
      end do

c     graficni del

      st=0	  !s tem preverjam ce sem ze izvrsil kaksno transformacijo,
		  !zaradi izrisa deformiranega stanja
498   continue
      nt=0	  !stevec zaradi mnozenja transformacijskih matrik
      call gopks()
      call gswkvp(1,200.,20.,640.,460.)
      call gswn(1,-1000.,-1000.,lmax+500.,lmax+500.)

      write(*,*)'Izberi opcijo'
      write(*,*)
      write(*,*)'<t> translacija'
      write(*,*)'<s> skaliranje'
      write(*,*)'<x> rotacija x'
      write(*,*)'<y> rotacija y'
      write(*,*)'<z> rotacija z'
      write(*,*)'<i> izris'
      write(*,*)'<e> prvotno stanje'
      write(*,*)'<d> deformirano stanje'
      write(*,*)'<v> vozlisca'
      write(*,*)'<p> palice'
      write(*,*)'<n> notranje sile'
      write(*,*)'<m> pomiki vozlisc'
      write(*,*)'<ostale tipke> izhod'

      call risanje(members,incid,x,y)

499   continue
      read(*,'(A)')opcija

      if(opcija(1:2).eq.'t')then
      write(*,*)'podaj Dx, Dy, Dz'
      read(*,*)dx,dy,dz
      call tr(st,nt,a,dx,dy,dz)
      call trma(f,a,nt)
      go to 499

      else if(opcija(1:2).eq.'s')then
      write(*,*)'podaj Sx, Sy, Sz'
      read(*,*)sx,sy,sz
      call sk(st,nt,b,sx,sy,sz)
      call trma(f,b,nt)
      go to 499

      else if(opcija(1:2).eq.'x')then
      write(*,*)'podaj kot fi'
      read(*,*)fi
      fi=0.01745329252*fi
      call rox(st,nt,c,fi)
      call trma(f,c,nt)
      go to 499

      else if(opcija(1:2).eq.'y')then
      write(*,*)'podaj kot fi'
      read(*,*)fi
      fi=0.01745329252*fi
      call roy(st,nt,d,fi)
      call trma(f,d,nt)
      go to 499

      else if(opcija(1:2).eq.'z')then
      write(*,*)'podaj kot fi'
      read(*,*)fi
      fi=0.01745329252*fi
      call roz(st,nt,e,fi)
      call trma(f,e,nt)
      go to 499

      else if(opcija(1:2).eq.'i')then
      call mno(joints,x,y,z,f)
      go to 498

      else if(opcija(1:2).eq.'e')then
      go to 496

      else if(opcija(1:2).eq.'d')then
	if(st.gt.0)then
      call mno(joints,xd,yd,zd,f)
	else
	continue
	end if
      call def(members,no,incid,xd,yd)
      go to 499

      else if(opcija(1:2).eq.'v')then
      go to 500

      else if(opcija(1:2).eq.'p')then
      go to 501

      else if(opcija(1:2).eq.'n')then
      go to 502

      else if(opcija(1:2).eq.'m')then
      go to 503

      else
      go to 504
      end if

500   continue
      call gstxci(14)
      call gschh(10)
      do i=1,joints                            !vozlisca
      write(cnode,'(I3)')i
      call gtx(x(i),y(i)+2.0,cnode)
      end do
      go to 499

501   continue
      call gschh(14)
      call gstxci(9)
      do i=1,members
      write(cnode,'(I3)')i                     !palice
      x1=(3*x(incid(i,1))+x(incid(i,2)))/4-100
      y1=(3*y(incid(i,1))+y(incid(i,2)))/4
      call gtx(x1,y1,cnode)
      end do
      go to 499

502   continue
      call gschh(14)
      call gstxci(3)
      do i=1,members
      write(cnode,'(f8.0)')no(i)                   !notranje sile
      x1=(x(incid(i,1))+3*x(incid(i,2)))/4-400
      y1=(y(incid(i,1))+3*y(incid(i,2)))/4
      call gtx(x1,y1,cnode)
      end do
      go to 499

503   continue
      call gschh(14)
      call gstxci(5)
      do i=1,joints
        do j=1,dim
	write(cnode,'(f7.3)')pomik(i,j)
        x1=x(i)
        y1=y(i)-(j-1)*150+200
        call gtx(x1,y1,cnode)
        end do
      end do
      go to 499

c     zapre GKS
      call gclks()
504   continue

      return
      end

******************************************************************************

      subroutine tr(st,nt,a,dx,dy,dz)
      integer st,nt
      real a(4,4)
      st=st+1
      nt=nt+1
      a=0.0
      a(1,1)=1
      a(2,2)=1
      a(3,3)=1
      a(4,1)=dx
      a(4,2)=dy
      a(4,3)=dz
      a(4,4)=1
      return
      end

      subroutine sk(st,nt,b,sx,sy,sz)
      integer st,nt
      real b(4,4)
      st=st+1
      nt=nt+1
      b=0.0
      b(1,1)=sx
      b(2,2)=sy
      b(3,3)=sz
      b(4,4)=1
      return
      end

      subroutine rox(st,nt,c,fi)
      integer st,nt
      real c(4,4)
      st=st+1
      nt=nt+1
      c=0.0
      c(1,1)=1
      c(2,2)=cos(fi)
      c(2,3)=sin(fi)
      c(3,2)=-sin(fi)
      c(3,3)=cos(fi)
      c(4,4)=1
      return
      end

      subroutine roy(st,nt,d,fi)
      integer st,nt
      real d(4,4)
      st=st+1
      nt=nt+1
      d=0.0
      d(1,1)=cos(fi)
      d(1,3)=-sin(fi)
      d(2,2)=1
      d(3,1)=sin(fi)
      d(3,3)=cos(fi)
      d(4,4)=1
      return
      end

      subroutine roz(st,nt,e,fi)
      integer st,nt
      real e(4,4)
      st=st+1
      nt=nt+1
      e=0.0
      e(1,1)=cos(fi)
      e(1,2)=sin(fi)
      e(2,1)=-sin(fi)
      e(2,2)=cos(fi)
      e(3,3)=1
      e(4,4)=1
      return
      end

      subroutine trma (a,b,nt)
      integer nt
      real a(4,4),b(4,4),c(4,4),d(4,4)
      if(nt.eq.1)then
	 do i=1,4
	   do j=1,4
	   a(i,j)=b(i,j)
	   end do
	 end do
      else
	 do i=1,4
	   do k=1,4
	     p=0
	     do j=1,4
	     c(i,k)=b(j,k)*a(i,j)
	     p=p+c(i,k)
	     end do
	   d(i,k)=p
	   end do
	 end do

	 do i=1,4
	   do k=1,4
	   a(i,k)=d(i,k)
	   end do
	 end do
      end if
      return
      end

      subroutine mno(joints,x,y,z,b)
      parameter (NMAX=800)
      integer joints
      real x(NMAX),y(NMAX),z(NMAX),b(4,4),a(4),c(4),d(4)

      do r=1,joints
	a(1)=x(r)
	a(2)=y(r)
	a(3)=z(r)
	a(4)=1
	  do j=1,4
	    p=0
	    do i=1,4
	    c(i)=a(i)*b(i,j)
	    p=p+c(i)
	    end do
	    d(j)=p
	  end do
	  x(r)=d(1)
	  y(r)=d(2)
	  z(r)=d(3)
      end do
      return
      end

      subroutine risanje(members,incid,x,y)  
      parameter (NMAX=800)
      integer members,incid(NMAX,3)
      real x(NMAX),y(NMAX),xx(NMAX),yy(NMAX)
      call gsplci(7)
      do i=1,members
	xx(1)=x(incid(i,1))
	yy(1)=y(incid(i,1))
	xx(2)=x(incid(i,2))
	yy(2)=y(incid(i,2))
      call gpl(2,xx,yy)
      end do
      return
      end

      subroutine def(members,no,incid,xd,yd) 
      parameter (NMAX=800)
      integer members,incid(NMAX,3)
      real no(NMAX),xd(NMAX),yd(NMAX),xx(NMAX),yy(NMAX)
      do i=1,members
       if(no(i).lt.0)then
       call gsplci(4)
       else
       call gsplci(2)
       end if
	xx(1)=xd(incid(i,1))
	yy(1)=yd(incid(i,1))
	xx(2)=xd(incid(i,2))
	yy(2)=yd(incid(i,2))
      call gpl(2,xx,yy)
      end do
      return
      end
