      program Izracun
c     resevanje staticno nedolocenega palicja
c     branje podatkov
                                                                
      parameter (NMAX=800)                                                          
      integer joints, members, reactions, loads, ds(NMAX), g(NMAX)
      real coord(NMAX,3), force(NMAX,3), AE(NMAX,3)
      real l(NMAX), k(NMAX,NMAX), d(NMAX,NMAX), obr(NMAX), ob(NMAX) 
      real re(NMAX), no(NMAX), dl(NMAX)
      integer s, p, i, a, b, dim /2/, os1, os2, f, c, os(NMAX)
      integer x(NMAX), in(NMAX), incid(NMAX,3), stev(NMAX)
      character vrst*80, smer*10, ime_dat*12

      write(*,'(A,/)')' Podaj ime vhodne datoteke'
      read(*,'(A)')ime_dat

      open(unit=1,file=ime_dat,status='old',err=1000)
      open(unit=2,file='coord.txt')
      open(unit=3,file='rezultat.prn')
      open(unit=4,file='gks.bin',access='direct',
     &form='binary',recl=58)

10    continue
      read(1,'(A)',err=1001)vrst

      if(vrst(1:5).eq.'plane')then
      dim=2
      elseif(vrst(1:5).eq.'space')then
      dim=3
      end if

      if(vrst(1:6).eq.'joints')then
      read(vrst(7:80),'(I5)',err=1002)joints
      end if

      if(vrst(1:7).eq.'members')then
      read(vrst(8:80),'(I5)',err=1003)members
      end if

      if(vrst(1:9).eq.'reactions')then
      read(vrst(10:80),'(I5)',err=1004)reactions
      end if

      if(vrst(1:5).eq.'loads')then
      read(vrst(6:80),'(I5)',err=1005)loads
      end if


      if(vrst(1:5).eq.'coord')then
      do 20 i=1,joints
              if(dim.eq.2)then
              read(1,*,err=1006)j,z1,z2
              coord(j,1)=z1
	      coord(j,2)=z2			 !branje koordinat
						 !j...stevilka vozlisca
              elseif(dim.eq.3)then
              read(1,*,err=1006)j,z1,z2,z3
              coord(j,1)=z1
	      coord(j,2)=z2
              coord(j,3)=z3
	      end if
	      do a=1,dim
	      write(2,*)coord(j,a)
	      end do
20    continue
      end if


      if(vrst(1:5).eq.'incid')then
      do 30 i=1,members
      read(1,*,err=1007)f,v1,v2,t
      stev(i)=f
      incid(f,1)=v1				      !seznam palic
      incid(f,2)=v2				      !f...stevilka palice
      AE(f,3)=t
30    continue
      end if

      if(vrst(1:5).eq.'force')then
      obr=0
      do 40 i=1,loads
	 if(dim.eq.2)then			      !zunanje obremenitve
	 read(1,*,err=1008)s,fx,fy		      !s...vozlisce v katerem
	 force(s,1)=fx				      !prijemlje zunanja sila
         force(s,2)=fy

	 else if(dim.eq.3)then
         read(1,*,err=1008)s,fx,fy,fz
         force(s,1)=fx
         force(s,2)=fy
         force(s,3)=fz
	 end if

	 do os1=1,dim
	 obr(dim*(s-1)+os1)=force(s,os1)	      !to je vektor zunanjih
	 end do 				      !obremenitev
40    continue
      end if

      if(vrst(1:5).eq.'suppo')then
      do 50 i=1,reactions
      read(1,'(I2,$)')g(i)			       !vozlisca s podporami
      read(1,'(A)',err=1009)smer

      if((smer(1:2).eq.'x').or.(smer(2:3).eq.'x'))then
      os(i)=1						     !smeri reakcij
      else if((smer(1:2).eq.'y').or.(smer(2:3).eq.'y'))then
      os(i)=2
      else
      os(i)=3
      end if
50    continue
      end if

      if(vrst(1:5).eq.'solve')then
      goto 99
      end if

      goto 10

1000  write(*,*)'napaka pri odpiranju datoteke'

1001  stop 'napaka pri branju tekstovnega dela!'
1002  stop 'napaka pri branju parametra joints!'
1003  stop 'napaka pri branju parametra members!'
1004  stop 'napaka pri branju parametra reactions!'
1005  stop 'napaka pri branju parametra loads!'
1006  stop 'napaka pri branju parametra coord!'
1007  stop 'napaka pri branju parametra incid!'
1008  stop 'napaka pri branju parametra force!'
1009  stop 'napaka pri branju smeri reakcij!'

99    write(*,*) 'prebral sem ze'
      close(2)
c*****************************************************************************
c*****************************************************************************
c     generiranje togostne matrike

      do 60 f=1,members
	 a=incid(f,2)
	 b=incid(f,1)
	 l(f)=0
	 do i=1,dim				       !dolzine palic l
         l(f)=l(f)+(coord(a,i)-coord(b,i))**2
         end do
      l(f)=sqrt(l(f))
60    continue

c     pa se lotimo matrike
      k=0
      do 80 i=1,joints
		do f=1,members
		if((incid(f,1).eq.i).or.(incid(f,2).eq.i))then
		p=f
		else
		go to 81
		end if

		if(incid(p,1).eq.i)then
		j=incid(p,2)
		else
		j=incid(p,1)
		end if
	do 90 os1=1,dim
	do 100 os2=1,dim
		m=dim*(i-1)+os1
		n=dim*(j-1)+os2
      k(m,n)=(coord(i,os1)-coord(j,os1))/(l(p))**3*
     &AE(p,3)*(coord(i,os2)-coord(j,os2))
100	continue
90	continue
81		continue
		end do

      do os1=1,dim
      do os2=1,dim
	 do j=1,joints
      d(dim*(i-1)+os1,dim*(i-1)+os2)=d(dim*(i-1)+os1,dim*(i-1)+os2)-
     &k(dim*(i-1)+os1,dim*(j-1)+os2)
	 end do
      k(dim*(i-1)+os1,dim*(i-1)+os2)=d(dim*(i-1)+os1,dim*(i-1)+os2)
      end do
      end do

80    continue

c permutacija matrike
         ds=0
         do j=1,reactions
         p=dim*(g(j)-1)+os(j)
         ds(p)=1
	 end do 			     !pregledam, kje ni pomikov
      do p=1,dim*joints
      x(p)=p
      end do

      m=dim*joints
      ii=0
      do 110 i=1,m-reactions
      if(ds(i).eq.1)then

c      c1=x(i)
	   do 120 j=m,reactions+1,-1
	   if(ds(j).eq.0)then
	   ii=ii+1
           if(ii.gt.reactions)then                    !stejem koliko zamenjav
           go to 51                                   !sem naredil
	   else
	      c1=x(i)
              c2=x(j)
	       ds(i)=0
	       ds(j)=1
                   do a=1,m
                   a1=k(i,a)
                   k(i,a)=k(j,a)            !zamenjava vrstic
                   k(j,a)=a1
		   end do

                   do b=1,m
                   a1=k(b,i)
                   k(b,i)=k(b,j)            !zamenjava stolpcev
                   k(b,j)=a1
		   end do

                   x(i)=c2
		   x(j)=c1		    !oznacim kateri dve
		   go to 52		    !mesti zamenjam

	      end if
	      end if
120           continue
      end if
52    continue
110   continue
51    continue

      c=dim*joints-reactions

      do i=1,dim*joints 	     !nov vrstni red stolpcev in
      ob(i)=obr(x(i))		     !obremenitev
      end do

c     sedaj moram samo se resiti sisteme enacb

      call ludcmp(k,c,NMAX,indx,d)

      call lubksb(k,c,NMAX,indx,ob)

      do i=c+1,dim*joints
      do j=1,dim*joints
      rea=k(i,j)*ob(j)
      re(i)=re(i)+rea                       !izracun reakcij
      end do
      end do

      d=0
      do i=1,c
      if(i.eq.1)then
      write(3,'(A)')'pomiki vozlisc'
      end if
      ob(i)=-ob(i)

      s=(x(i)-1)/dim
      in(i)=s+1				    !tukaj racuna indekse
      os1=x(i)-s*dim

      if(os1.eq.1)then
      d(in(i),1)=ob(i)
      write(3,'(A I2 A f10.4 A)')'dx',in(i),'=',ob(i),' mm'	!izpis pomikov
      else if(os1.eq.2)then					!in zapis le
      d(in(i),2)=ob(i)						!teh v
      write(3,'(A I2 A f10.4 A)')'dy',in(i),'=',ob(i),' mm'	!dvodim.
      else if(os1.eq.3)then					!polje
      d(in(i),3)=ob(i)
      write(3,'(A I2 A f10.4 A)')'dz',in(i),'=',ob(i),' mm'
      end if
      end do

      do i=c+1,dim*joints
      if(i.eq.c+1)then
      write(3,'(/ A)')'reakcije v podporah'
      end if
      s=(x(i)-1)/dim
      in(i)=s+1
      os1=x(i)-s*dim
      if(os1.eq.1)then
      write(3,'(A I2 A f10.2 A)')'Rx',in(i),'=',re(i),' N'    !izpis reakcij
      else if(os1.eq.2)then
      write(3,'(A I2 A f10.2 A)')'Ry',in(i),'=',re(i),' N'
      else if(os1.eq.3)then
      write(3,'(A I2 A f10.2 A)')'Rz',in(i),'=',re(i),' N'
      end if
      end do

      open(2,file='coord.txt',status='old')
      do i=1,joints
      do j=1,dim			     !tu se enkrat prebere
      read(2,*)coord(i,j)		     !koordinate
      end do
      end do

      do 140 i=1,joints
		do f=1,members
		if((incid(f,1).eq.i).or.(incid(f,2).eq.i))then
		p=f
		else
		go to 53
		end if

		if(incid(p,1).eq.i)then
		j=incid(p,2)
		else
		j=incid(p,1)
		end if
		    dl(p)=0
		    do os1=1,dim
	dl(p)=dl(p)+(coord(i,os1)-coord(j,os1))*(d(i,os1)-d(j,os1))
		    end do
		dl(p)=dl(p)/l(p)
		no(p)=AE(p,3)/l(p)*dl(p)
53    continue
		end do
140   continue

      do i=1,members
      if(i.eq.1)then
      write(3,'(/ A)')'Notranje sile v palicah'
      end if
      write(3,'(A I2 A f10.2 A)')'N',i,' =',no(i),' N'
      end do

      write(*,*)'izracunal sem tudi'
      write(*,*)'rezultati so izpisani v datoteki rezultat.prn'
      write(*,*)'za prikaz pozeni program grafika.exe'

c  zapis v datoteko gks.bin
      write(4,rec=1)dim,joints,members
      do i=1,joints
      if(dim.eq.2)then
      coord(i,3)=0
      end if
      write(4,rec=2+i)coord(i,1),coord(i,2),coord(i,3)
      end do

      do j=1,members
      write(4,rec=3+joints+j)stev(j),incid(stev(j),1),
     &incid(stev(j),2),no(stev(j))
      end do

      do i=1,joints
         do j=1,dim
      write(4,rec=4+joints+members+dim*(i-1)+j)d(i,j)
         end do
      end do

      return
      end

c*****************************************************************************
c*****************************************************************************
c	   podprograma
      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END

c*****************************************************************************

      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=1400,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
      RETURN
      END

c*****************************************************************************
c*****************************************************************************
